# -*- coding: utf-8 -*-
"""YT-scrapper

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1n3Li3TR-3vJgI4GxkdbURZl8cm5a7tXi
"""

import pandas as pd
import csv
from pyyoutube import Api

keys = [""] #key for youtube API
i=0
api = Api(api_key=keys[i])

videos = ["IyEBRZsLZc8"] #video id from the link

header = ["Video ID","Author Name","Comment","Like Count","Published At"]
data = []
with open('/content/sample_data/youtube_comments.csv', 'w', encoding='UTF8') as f:
  writer = csv.writer(f)
  writer.writerow(header)

  for video in videos:
    try:
      comments=api.get_comment_threads(video_id=videos, count=None)
      c : dict=[]
      for comment in comments.items:
          try:
            c = api.get_comment_by_id(comment_id=comment.id)
            c=c.to_dict()
            item = c.get("items")[0]
            snippet = item.get("snippet")
            print(snippet.get("authorDisplayName"),snippet.get("textDisplay"))
            data.append([video,snippet.get("authorDisplayName"),snippet.get("textDisplay"),snippet.get("likeCount"),snippet.get("publishedAt")])
          except Exception as e:
            print(e)
            #loop for changing API keys automatically once quota for a key is full
            if(i < len(keys)):
              i=i+1
              api = Api(api_key=keys[i])
            else:
              break
    except Exception as e:
      print(e)
      #loop for changing API keys automatically once quota for a key is full
      if(i < len(keys)): 
          i=i+1
          api = Api(api_key=keys[i])
      else:
        break   
  writer.writerows(data)